"""
TwoCAs.  The first turns on the second.  The second stops the first.
I'm trying to figure out the nest2.6 syntax with
pyNN 0.8.2(b)?  Things have changed or are missing, but this works.
"""

#imports for PyNN
#from pyNN.utility import get_script_args
from nest import *

def nealProjection(preNeurons,postNeurons, connectorList):
    for connection in connectorList:
        Connect(preNeurons[connection[0]],postNeurons[connection[1]],
                {'weight':connection[2]})


#------------Main Body---------------
ResetKernel()

neurons=Create('iaf_cond_exp', n=5,
               params = {'C_m':50.0,'V_th': -60.0, 'V_reset': -70.0, 't_ref':1.0})

neurons2=Create('iaf_cond_exp', n=5,
               params = {'C_m':50.0,'V_th': -60.0, 'V_reset': -70.0, 't_ref':1.0})


inputSource=Create('spike_generator',params={'spike_times': [2.0,5.0]})

Connect(inputSource,neurons, syn_spec={'weight':40.0})
#Connect(neurons,neurons, model={'weight':10.0})
#Connect(neurons[0],neurons[0],{'weight':2.5})
connector = []
for fromOff in range(0,5):
    for toOff in range(0,5):
        connector=connector+[(fromOff,toOff,10.0)]
nealProjection(neurons,neurons,connector)
nealProjection(neurons,neurons2,connector)
nealProjection(neurons2,neurons2,connector)
connector = []
for fromOff in range(0,5):
    for toOff in range(0,5):
        connector=connector+[(fromOff,toOff,-20.0)]
nealProjection(neurons2,neurons,connector)

#Connect(neurons,neurons2, syn_spec={'weight':10.0})
#Connect(neurons2,neurons2, syn_spec={'weight':10.0})
#Connect(neurons2,neurons, syn_spec={'weight':-20.0})

mult = Create('multimeter', params = {'withtime': True, 
                          'interval': 1.0,
                          'record_from': ['V_m']})
Connect(mult, neurons)

Simulate(20.0)

#parse.printResults()
events = GetStatus(mult)[0]['events']
volts=events.items()[0]
volts=volts[1]
count = 0
for outp in volts:
    print count/5, ' ' , count % 5, ' ' ,outp
    count = count + 1



